
library unscripted.tool.grind;

import 'dart:io';

import 'package:grinder/grinder.dart';

void main(List<String> args) {
  task('init', Pub.get);
  task('analyze', analyze, ['init']);
  task('test', test, ['init']);
  task('coverage', coverage, ['init']);
  task('default', null, ['analyze', 'test', 'coverage']);

  startGrinder(args);
}

void analyze(GrinderContext context) {
  activateAndRun(context, 'tuneup', arguments: ['check']);
}

void test(GrinderContext context) {
  activateAndRun(context, 'test_runner');
}

coverage(GrinderContext context) {
  if (Platform.environment.containsKey('CI')) {
    activateAndRun(context, 'dart_coveralls', arguments: ['report', '--token', Platform.environment['REPO_TOKEN'], '--retry', '3', 'test/all_tests.dart']);
  }
}

activateAndRun(GrinderContext context, String package, {List<String> arguments}) {
  (new Pub().global)
    ..activate(context, package)
    ..run(context, package, arguments: arguments);
}
